/**
 * @fileOverview httpĹ߲ʱʱ
 * @author menglb
 * @module tool/httpHelper
 */
 
var http = require('http');
var https = require('https');
var qs = require('querystring');
var iconv = require('iconv-lite');
var BufferHelper = require('bufferhelper');


/*
httpHelper.get('http://www.google.com/', 10, function (err, data) {
                if (err && err.message === 'request timeout') {
                    return done();
                }
 
                done(new Error('ʱʱЧ'));
            }, 'gbk');
httpHelper.post(url, 1000, {}, function (err, data) {
                if (err) {
                    return done(err);
                }
                should.exist(data);
                done();
            }, 'gbk', {'User-Agent': 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.86 Safari/537.36'});
        });
*/
 
/**
 * @exports tool/httpHelper
 */
var httpHelper = {
 
    /**
     * @description ԶĻ
     * @param {Object} options ѡ
     * @param {String} [options.protocol='http'] Э
     * @param {String} [options.method='get'] 󷽷getpost...
     * @param {Object=} options.headers ͷ
     * @param {String=} options.encode ݵıʽgbkʹescape
     * @param {Boolean=} [options.json=false] ͵Ƿjson
     * @param {Boolean=} [options.buffer=false] Ƿֱӷض
     * @param {Number=} timeout ʱʱ䣬λΪ
     * @param {Object=} data ͵ݶ
     * @param {RequestCallback} callback ӦĻص鿴 {@link RequestCallback}
     * @param {String} [encoding='utf-8'] ʽ
     */
    request: function (options, timeout, data, callback, encoding) {
        var httpLib = http;
        if (options.protocol && options.protocol === 'https:') {
            httpLib = https;
        }
        var content = {};
        if (options.json) {
            content = JSON.stringify(data);
        } else {
            content = (options.encode && options.encode.toLocaleLowerCase() == 'gbk') ? qs.stringify(data, null, null, {encodeURIComponent: escape}) : qs.stringify(data);
        }
        if (options.method.toLowerCase() === 'post') {
            options.headers = options.headers || {};
            options.headers['Content-Type'] = options.json ? 'application/json' : 'application/x-www-form-urlencoded';
            options.headers['Content-Length'] = Buffer.byteLength(content);
        }
        /** Ϊtrueʱֱӷ */
        options.buffer = options.buffer || false;
 
        var req = httpLib.request(options, function (res) {
            var bufferHelper = new BufferHelper();
            res.on('data', function (chunk) {
                bufferHelper.concat(chunk);
            });
            res.on('end', function () {
                var _data;
                if (options.buffer) {
                    _data = bufferHelper.toBuffer();
                }
                else {
                    if (typeof encoding != 'undefined' && encoding !== null) {
						console.log("++++++++++++++++++++++++++++++++++++turn to " + encoding);
                        _data = iconv.decode(bufferHelper.toBuffer(), encoding);
                    } else {						
                        _data = iconv.decode(bufferHelper.toBuffer(), 'utf-8');
                    }
                }
                callback(null, _data, res, req);
            });
        });
 
        req.on('error', function (err) {
            callback(err);
        });
 
        //req.write(content);
 
        if (timeout && timeout > 0) {
            req.setTimeout(timeout, function () {
                callback(new Error('request timeout'), '');
            });
        }
 
        req.end();
    },
 
    /**
     * @description GETķʽԶ
     * @param {String} url ַ
     * @param {Number=} timeout ʱʱ䣬λΪ
     * @param {RequestCallback} callback ӦĻص鿴 {@link RequestCallback}
     * @param {String} [encoding='utf-8'] ʽ
     * @param {Object=} header ͷ
     */
    get: function (url, timeout, callback, encoding, header) {
        var options = require('url').parse(url);
        options.method = 'GET';
        if (header) {
            options.headers = header;
        }
 
        this.request(options, timeout, {}, callback, encoding);
    },
 
    /**
     * @description POSTķʽԶ
     * @param {String} url ַ
     * @param {Number=} timeout ʱʱ䣬λΪ
     * @param {Object=} data ͵ݶ
     * @param {RequestCallback} callback ӦĻص鿴 {@link RequestCallback}
     * @param {String} [encoding='utf-8'] ʽ
     * @param {Object=} header ͷ
     * @param {String=} reqEncoding ݵıʽgbkʹescape
     * @param {Boolean=} [json=false] ͵Ƿjson
     */
    post: function (url, timeout, data, callback, encoding, header, reqEncoding, json) {
        var options = require('url').parse(url);
        options.method = 'POST';
        if (header) {
            options.headers = header;
        }
        if (reqEncoding) {
            options.encode = reqEncoding;
        }
        if (json) {
            options.json = json;
        }
        this.request(options, timeout, data, callback, encoding);
    }
};
 
/**
 * @description ӦĻص
 * @callback RequestCallback
 * @param {Object} err ӦĴ
 * @param {string} data Ӧ
 * @param {Object} res Ӧ
 */
 
module.exports = httpHelper;