'use strict';

function sendMsg(msg,remote)
{
	var PORT = 9795;
	var HOST = remote.address;
	
	var dgram = require('dgram');
	var message = new Buffer(msg);
	
	var client = dgram.createSocket('udp4');
	client.send(message, 0, message.length, PORT, HOST, function(err, bytes) {
		if (err) throw err;
		console.log('UDP message sent to ' + HOST +':'+ PORT);
		client.close();
	});
}
function udp_handle(message, remote,pcwd)
{
	if(''==message || null == message) return;
	var utl = require('util');
	if(-1==utl.format("%s",message).search("{.*}")) return;
	var jmsg = JSON.parse(message);
	
	if(jmsg.cmd == 'down')
	{
		var httpDown=require('httpdown');
		var url =jmsg.param;
		httpDown.download(url,pcwd,60000,function(status){
			status.task_index = jmsg.task_index;
			var msg = JSON.stringify(status);
			sendMsg(msg,remote);
		});
		
	}
}
function startWork(dirname)
{
	var PORT = 9794;
	var HOST = '0.0.0.0';
	
	var dgram = require('dgram');
	var server = dgram.createSocket('udp4');
	var pcwd = dirname;
	server.on('listening', function () {
		var address = server.address();
		console.log('UDP Server listening on ' + address.address + ":" + address.port);
	});
	
	server.on('message', function (message, remote) {
		console.log(remote.address + ':' + remote.port +' - ' + message);
		udp_handle(message, remote,pcwd);
	});
	
	server.bind(PORT, HOST);
}
function test()
{
	var remote={port:9795,address:'127.0.0.1'};
	sendMsg("test hello",remote);
}
exports.startWork=startWork;
exports.test=test;
